/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package moe.nekojimi.nodeprocessor.nodes;

import java.util.Iterator;
import moe.nekojimi.nodeprocessor.Program;
import moe.nekojimi.nodeprocessor.ports.InPort;
import moe.nekojimi.nodeprocessor.ports.OutPort;

public class SerialiserNode<T> extends Node
{

    private final Class<Iterable<T>> aClass;
    private final Class<T> clazz;

    public SerialiserNode(Program scene, Class<T> clazz)
    {
        super(scene);
        Iterable<T> it = () ->
        {
            throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
        };
        aClass = (Class<Iterable<T>>) it.getClass();
        addInPort(new InPort("in", aClass, this));
        this.clazz = clazz;
        addOutPort(new OutPort("out", clazz, this));
    }

    @Override
    public boolean process()
    {
        InPort<Iterable<T>> inPort = getInPort("in", aClass);
        OutPort<T> outPort = getOutPort("out", clazz);
        if (inPort.has())
        {
            Iterable<T> iterable = inPort.get();
            Iterator<T> iterator = iterable.iterator();
            while (iterator.hasNext())
            {
                outPort.set(iterator.next());
            }
        }
        return true;
    }

    @Override
    public boolean check()
    {
        InPort<Iterable<T>> inPort = getInPort("in", aClass);
        return inPort.has();
    }

}
