/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package moe.nekojimi.nodeprocessor.nodes;

import moe.nekojimi.nodeprocessor.Program;
import moe.nekojimi.nodeprocessor.ports.InPort;
import moe.nekojimi.nodeprocessor.ports.OutPort;

public class ValueNode<T> extends Node
{

    private T value;

    private final OutPort<T> outPort;
    private final InPort<T> inPort;

    public ValueNode(Program scene, Class<T> clazz)
    {
        super(scene);
        inPort = new InPort("set", clazz, this);
        addInPort(inPort);
        outPort = new OutPort("out", clazz, this);
        addOutPort(outPort);
    }

    public void setValue(T val)
    {
        value = val;
//        signal();
    }

    public T getValue()
    {
        return value;
    }

    @Override
    public boolean process()
    {
        if (inPort.has())
            value = inPort.get();
        outPort.set(value);
        return true;
    }

    @Override
    public boolean check()
    {
        return true;
    }

}
