/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package moe.nekojimi.nodeprocessor.ports;

import moe.nekojimi.nodeprocessor.links.Link;
import moe.nekojimi.nodeprocessor.nodes.Node;

/**
 *
 * @author jimj316
 */
public class InPort<T> extends Port<T>
{

    public InPort(String name, Class<T> clazz, Node node)
    {
        super(name, clazz, node);
    }

    public boolean has()
    {
        if (links.isEmpty())
            return false;
        else
            return links.stream().anyMatch((l) -> l.has());
    }

    public T get()
    {
        for (Link<T, ?, ?> link : links)
        {
            if (link.has())
                return link.read();
        }
        for (Link<T, ?, ?> link : links)
        {
            link.pull(); // push the from side to prompt it to give us a value; it goes in the queue
            node.signal(); // push the to side to receive the new value (or not)
        }
        return null;
    }

    public void signal()
    {
        node.signal();
    }

}
