/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package moe.nekojimi.nodeprocessor.ports;

import moe.nekojimi.nodeprocessor.links.Link;
import moe.nekojimi.nodeprocessor.nodes.Node;

/**
 *
 * @author jimj316
 */
public class OutPort<T> extends Port<T>
{

    public OutPort(String name, Class<T> clazz, Node node)
    {
        super(name, clazz, node);
    }

    public void set(T value)
    {
        for (Link<T, ?, ?> link : links)
        {
            link.write(value);
        }
    }

    public void pull()
    {
        node.signal();
    }

    @Override
    public void connect(Link<T, ?, ?> link)
    {
        super.connect(link);
        // also re-order the links into dependency order
        links.sort((Link a, Link b) ->
        {
            Node aNode = a.getTo().getNode();
            Node bNode = b.getTo().getNode();
            return Node.DEPENDENCY_ORDER.compare(aNode, bNode);
        });
    }


}
